﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Billboard : MonoBehaviour
{
	public Camera mainCamera;
	[Header( "Properties" )]
	public bool yawOnly = false;

	void LateUpdate()
	{
		if ( yawOnly )
		{
			Vector3 euler = transform.eulerAngles;
			euler.y = Utility.directionYaw( mainCamera.transform.position, transform.position );
			transform.eulerAngles = euler;
		}
		else
		{
			transform.LookAt( transform.position + mainCamera.transform.rotation * Vector3.forward, mainCamera.transform.rotation * Vector3.up );
		}
	}
}
