﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Waves : MonoBehaviour
{
	public Transform[] spawnPoints;
	public GameObject enemy;
	public Hive hive;
	public HUD hud;
	[Header( "Properties" )]
	public int spawnPerWave;
	public Vector2 spawnDelayRange;
	public float waveStartDelay;
	public int round;

	private bool waveStart = true;
	private float spawnDelay;
	private int spawnIndex;
	private float waveStartDelta;

	void Start()
	{
		hud.newRound();
	}

	void Update()
	{
		waveStartDelta -= Time.deltaTime;
		spawnDelay -= Time.deltaTime;
		if ( waveStartDelta <= 0f && hive.enemies.Count < 15 && waveStart && spawnDelay <= 0f && spawnIndex < spawnPerWave )
		{
			spawnDelay = Random.Range( spawnDelayRange.x, spawnDelayRange.y );
			Vector3 spawnPos = spawnPoints[Random.Range( 0, spawnPoints.Length )].position;
			spawnPos.y = enemy.transform.position.y;
			GameObject impact = Instantiate( enemy );
			impact.SetActive( true );
			impact.transform.position = spawnPos;
			spawnIndex++;
		}

		if ( spawnIndex >= spawnPerWave && hive.enemies.Count <= 0 )
		{
			spawnIndex = 0;
			waveStart = false;
			waveStartDelta = waveStartDelay;
		}

		if ( waveStart == false && waveStartDelta <= 0f )
		{
			waveStart = true;
			round++;
			Enemy enemyScript = enemy.GetComponent<Enemy>();
			enemyScript.health += 25;
			enemyScript.attackStrength += 5;
			UnityEngine.AI.NavMeshAgent agent = enemy.GetComponent<UnityEngine.AI.NavMeshAgent>();
			agent.speed = Mathf.Min( agent.speed + 0.3f, 5f );
			spawnPerWave += 5;
			hud.newRound();
		}
	}
}
